import re
from unicodedata import normalize


def slugify(string):
    name = normalize('NFKD', string).encode('ascii', 'ignore').replace(' ', '-').lower()
    # remove `other` characters
    name = re.sub('[^a-zA-Z0-9_-]', '', name)
    # nomalize dashes
    name = re.sub('-+', '-', name)

    return name


def gen_code_name(string: str, max_len: int = 25) -> str:
    return slugify(string)[:max_len]